[Leetcode] 376. Wiggle Subsequence 解题报告

来源:互联网 发布:个人定位软件 编辑:程序博客网 时间:2024/06/06 08:26

题目

A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.

For example, [1,7,4,9,2,5] is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast, [1,4,7,2,5] and [1,7,4,5,5] are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.

Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.

Examples:

Input: [1,7,4,9,2,5]Output: 6The entire sequence is a wiggle sequence.Input: [1,17,5,10,13,15,10,5,16,8]Output: 7There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8].Input: [1,2,3,4,5,6,7,8,9]Output: 2

Follow up:
Can you do it in O(n) time?

思路

1、动态规划:由于Wiggle subsequence的最后一段既有可能是升序,也有可能是降序,所以我们需要定义两个数组in和de,其中in[i]表示以第i个元素为升序结尾的子序列的最大长度,de[i]表示以第i个元素为降序结尾的子序列的最大长度。那么状态转移方程就为:in[i] = max(de[j] + 1),其中j < i 并且nums[j] < nums[i];de[i] = max(in[j] + 1),其中j < i并且nums[j] > nums[i]。最后遍历一遍求出in和de数组中的最大值返回。动态规划的时间复杂度是O(n^2),空间复杂度是O(n)。

2、贪心法:实际上该题目最好的解决方法是贪心:对于任何一个序列而言,我们只需要消除其多余的连续递增或者递减区间,剩余的就是它的最长Wiggle子序列。这种方法的时间复杂度是O(n),空间复杂度是O(1)。

代码

1、动态规划:

class Solution {public:    int wiggleMaxLength(vector<int>& nums) {        if(nums.size() <= 1) {            return nums.size();        }        vector<int> in(nums.size(), 1), de(nums.size(), 1);        for(int i = 1; i < nums.size(); ++i) {            for(int j = 0; j < i; ++j) {                if(nums[j] < nums[i] && de[j] + 1 > in[i]) {                    in[i] = de[j] + 1;                }                if(nums[j] > nums[i] && in[j] + 1 > de[i]) {                    de[i] = in[j] + 1;                }            }        }        int ret = 0;        for(int i = 0; i < nums.size(); ++i) {            ret = max(ret, max(in[i], de[i]));        }        return ret;    }};

2、贪心法:

class Solution {public:    int wiggleMaxLength(vector<int>& nums) {        if(nums.size() <= 1) {            return nums.size();          }        int ans = nums.size();        int flag = 0;  // indicate the whether the last pair is increase or decrease        for(int i = 1; i < nums.size(); i++) {              if(nums[i] - nums[i - 1] == 0) {                --ans;              }            else if(nums[i] - nums[i - 1] > 0) {    // flag == 1 means the last pair is increase                flag == 1 ? --ans : flag = 1;              }            else if(nums[i] - nums[i - 1] < 0) {    // flag == -1 means the last pair is decrease                flag == -1 ? -- ans : flag = -1;              }        }          return ans;    }};

原创粉丝点击